//************************************************************************************
//**  
//**  File name:     C:\Projekte_Flowcode\PIC_18F14K50\Error\USB_Test_3.c
//**  Generated by:  Flowcode v4.5.17.73
//**  Date:          Sunday, August 28, 2011 16:34:34
//**  Licence:       Professional
//**  Registered to: HansJrgen Halder 
//**  
//**  
//**  http://www.matrixmultimedia.com
//************************************************************************************


#define MX_PIC

//Definitionen fr Microcontroller
#define P18F14K50
#define MX_EE
#define MX_EE_TYPE3
#define MX_EE_SIZE 256
#define MX_SPI
#define MX_SPI_BCB
#define MX_SPI_SDI 4
#define MX_SPI_SDO 7
#define MX_SPI_SCK 6
#define MX_UART
#define MX_UART_B
#define MX_UART_TX 7
#define MX_UART_RX 5
#define MX_I2C
#define MX_MI2C
#define MX_I2C_B
#define MX_I2C_SDA 4
#define MX_I2C_SCL 6
#define MX_PWM
#define MX_PWM_CNT 1
#define MX_PWM_TRIS1 trisc
#define MX_PWM_1 5
#define MX_USB_TYPE3

//Funktionen
#define MX_CLK_SPEED 48000000
#ifdef _BOOSTC
#include <system.h>
#endif
#ifdef HI_TECH_C
#include <pic18.h>
#endif

//Konfigurations-Daten
#ifdef _BOOSTC
#pragma DATA 0x300000, 0x0
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300001, 0xf6
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300002, 0x3f
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300003, 0x1e
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300004, 0xff
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300005, 0x88
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300006, 0x89
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300007, 0xff
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300008, 0x3
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x300009, 0xc0
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x30000a, 0x3
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x30000b, 0xe0
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x30000c, 0x3
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif
#ifdef _BOOSTC
#pragma DATA 0x30000d, 0x40
#endif
#ifdef _HI_TECH_C
%C__CONFIG(%A, %V);
#endif

//Interne Funktionen
#include "C:\Program Files (x86)\Matrix Multimedia\Flowcode V4\FCD\internals.h"

//Makro-Funktions-Deklarationen


//Variablen-Deklarationen
char FCV_RET;




//USBSerial(0): //Defines:

/**** Macro Substitutions ****
0x12BF = Vendor ID
0xF010 = Product ID
{40,3,'F',0,'l',0,'o',0,'w',0,'c',0,'o',0,'d',0,'e',0,' ',0,'U',0,'S',0,'B',0,' ',0,'S',0,'e',0,'r',0,'i',0,'a',0,'l',0}; = Device Name
{46,3,'M',0,'a',0,'t',0,'r',0,'i',0,'x',0,' ',0,'M',0,'u',0,'l',0,'t',0,'i',0,'m',0,'e',0,'d',0,'i',0,'a',0,' ',0,'L',0,'t',0,'d',0,'.',0}; = Device manufacturer
0 = Version Number A
1 = Version Number B
10 = Enumeration Wait Enable
0 = Enumeration Wait Time
40 = Length of Device Name String
46 = Length of Device Manufacturer String
******************************/

	// Component Defines
	#define MX_VID 			0x12BF				//Eg 0x04D8
	#define MX_PID 			0xF010				//Eg 0x000C

	#define MX_VERSION		(1	<< 8) + 0	//Eg 0x0200 = 2.0
	#define MX_ENUMTIME		10				//Eg 1 - 255
	#define MX_ENUMWAIT		0				//Eg 1 or 0


	// Device name and manufacturer
	char MX_USBNAME[40] = {40,3,'F',0,'l',0,'o',0,'w',0,'c',0,'o',0,'d',0,'e',0,' ',0,'U',0,'S',0,'B',0,' ',0,'S',0,'e',0,'r',0,'i',0,'a',0,'l',0};
	char MX_USBMFR[46] = {46,3,'M',0,'a',0,'t',0,'r',0,'i',0,'x',0,' ',0,'M',0,'u',0,'l',0,'t',0,'i',0,'m',0,'e',0,'d',0,'i',0,'a',0,' ',0,'L',0,'t',0,'d',0,'.',0};


	// Global Defines
	#define CDC_TX_BUFFER_SIZE 	64
	#define CDC_RX_BUFFER_SIZE 	64
	#define CDC_DATA_ENDPOINT	3
	#define USB_HIGHEST_EP 		3
	#define USB_BUS_POWERED

	#ifdef MX_USB_TYPE1									//2455 Family
		#define USB_DESCRIPTOR_BASE_ADDRESS	0x400
		#define USB_EP0_OUT_ADDR 	0x0500
		#define USB_EP0_IN_ADDR 	0x0508
		#define USB_EP2_IN_ADDR		0x0510
		#define USB_EP3_OUT_ADDR	0x0518
		#define USB_EP3_IN_ADDR		0x0520
	#endif

	#ifdef MX_USB_TYPE2									//2450 Family
		#define USB_DESCRIPTOR_BASE_ADDRESS	0x400
		#define USB_EP0_OUT_ADDR 	0x0480
		#define USB_EP0_IN_ADDR 	0x0488
		#define USB_EP2_IN_ADDR		0x0490
		#define USB_EP3_OUT_ADDR	0x0498
		#define USB_EP3_IN_ADDR		0x04A0
	#endif

	#ifdef MX_USB_TYPE3									//14K50 Family
		#define USB_DESCRIPTOR_BASE_ADDRESS	0x200
		#define USB_EP0_OUT_ADDR 	0x0280
		#define USB_EP0_IN_ADDR 	0x0288
		#define USB_EP2_IN_ADDR		0x0290
		#define USB_EP3_OUT_ADDR	0x0298
		#define USB_EP3_IN_ADDR		0x02A0
	#endif

	#ifndef USB_DESCRIPTOR_BASE_ADDRESS
		#error "Target device does not have USB functionality"
	#endif

	#define USB_EP0_OUT_SIZE 	8
	#define USB_EP0_IN_SIZE 	8
	#define USB_EP2_IN_SIZE		8
	#define USB_EP3_OUT_SIZE	8
	#define USB_EP3_IN_SIZE		8

	#define USB_CALLBACK_ON_SOF
	#define USB_CALLBACK_ON_DEVICE_CONFIGURED
	#define USB_CALLBACK_ON_CTRL_CLASS
	#define USB_EP_DATA_CALLBACK

	//Serial Number
	char MX_SERIAL[10] = {10,3,'0',0,'0',0,'0',0,'1',0};

	// USB library includes
	#ifdef _BOOSTC
		#include <USB/pic_utils.h>
		#include <USB/pic_usb_buffer_mgt.c>
		#include <USB/pic_usb.c>
		#include <USB/usb_cdc_class.c>
		#include <USB/usb_config_serial.c>
	#endif

	#ifdef HI_TECH_C
		#include "USB/pic_utils.h"
		#include "USB/pic_usb_buffer_mgt.c"
		#include "USB/pic_usb.c"
		#include "USB/usb_cdc_class.c"
		#include "USB/usb_config_serial.c"
	#endif


	// Variable to hold status of the USB connection
	char CDC_USB_status = 0;

	// Variable to hold incoming data
	char CDC_USB_Rx_String[CDC_RX_BUFFER_SIZE];


	void usb_device_configured_callback(void)
	{
		CDC_USB_status = 1;
	}




//USBSerial(0): //Makro-Funktions-Deklarationen

void FCD_USBSerial0_configure_system();
char FCD_USBSerial0_Initialise_Serial();
char FCD_USBSerial0_SendByte(char byte);
char FCD_USBSerial0_SendString(char* String, char MSZ_String);
char FCD_USBSerial0_ReadByte(char timeout_ms);
void FCD_USBSerial0_ReadString(char* FCR_RETVAL, char FCR_RETVAL_SIZE, char timeout_ms, char length);



//USBSerial(0): //Makro-Implementierungen


void FCD_USBSerial0_configure_system()
{
		kill_interrupts();				// turn off interrupts just in case
		usb_cdc_setup();
		usb_setup();
		turn_peripheral_ints_on();
		turn_global_ints_on();
}

char FCD_USBSerial0_Initialise_Serial()
{
		uns16 delay_counter;

		usb_configure_structures();
		FCD_USBSerial0_configure_system();

		usb_enable_module();

		delay_counter = 0;

		#if MX_ENUMWAIT == 1

			while(CDC_USB_status == 0 && delay_counter < 10000)	//Wait for USB to startup and enumerate
			{
				delay_counter = delay_counter + 1;
				delay_10us(MX_ENUMTIME);						//Max wait
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
				delay_10us(MX_ENUMTIME);
			}

			if (CDC_USB_status == 1)
				return 0;
			return 0xFF;

		#else

			while(CDC_USB_status == 0);

		#endif
		return 0;
}

char FCD_USBSerial0_SendByte(char byte)
{
		unsigned int timeout = 0;

		while (usb_cdc_tx_empty() == 0 && timeout < 32000)	//Wait for outgoing buffer to empty
			timeout = timeout + 1;

		if (timeout == 32000)								//Pipeline full or disconnected
			return 1;

		usb_cdc_putc(byte);
		return 0;
}

char FCD_USBSerial0_SendString(char* String, char MSZ_String)
{
		unsigned int timeout = 0;

		while (usb_cdc_tx_empty() == 0 && timeout < 32000)	//Wait for outgoing buffer to empty
			timeout = timeout + 1;

		if (timeout == 32000)								//Pipeline full or disconnected
			return 1;

		usb_cdc_print_str(String);
		return 0;
}

char FCD_USBSerial0_ReadByte(char timeout_ms)
{
		static char position = 0;
		static char length = 0;
		char retval = 255;
		char waitforever = 0;

		if(timeout_ms == 255)
			waitforever = 1;

		if (position == length)									// end of local string?
		{
			position = 0;

			length = usb_cdc_rx_avail();						// get length of incoming data string

			while (length == 0 && (timeout_ms || waitforever))	// wait for timeout_ms
			{
				Wdt_Delay_Ms(1);
				length = usb_cdc_rx_avail();					// get length of incoming data string
				timeout_ms = timeout_ms - 1;					// decrement timeout_ms
			}

			if(length == 0)
				return (retval);								// return no data flag 255 / 0xFF

			usb_ep_get_rx_buffer(length, CDC_USB_Rx_String);	// copy data string to local buffer
		}

		retval = CDC_USB_Rx_String[position];

		position = position + 1;

		return (retval);
}

void FCD_USBSerial0_ReadString(char* FCR_RETVAL, char FCR_RETVAL_SIZE, char timeout_ms, char length)
{
		char waitforever = 0;
		char i;
		char Rx_Length;

		if(length > FCR_RETVAL_SIZE)
			length = FCR_RETVAL_SIZE;

		if(timeout_ms == 255)
			waitforever = 1;

		while (timeout_ms || waitforever)
		{
			Rx_Length = usb_cdc_rx_avail();					// get length of incoming data string
			if (Rx_Length)
			{
				if (Rx_Length > length)
					Rx_Length = length;

				usb_ep_get_rx_buffer(Rx_Length, FCR_RETVAL);	// copy data string to local buffer

				if (Rx_Length < length)
					FCR_RETVAL[Rx_Length] = 0;				//Add null character to end of string
				return;
			}
			else
			{
				Wdt_Delay_Ms(1);
				timeout_ms = timeout_ms - 1;
			}
		}
}

//Makro-Implementierungen

void main()
{
	
	//Initialisierung
	ansel = 0x00;
anselh = 0x00;

	
	    #if defined(P18F87J50) ||  defined(P18F86J55) || defined(P18F86J50) || defined(P18F85J50) || defined(P18F67J50) || defined(P18F66J55) || defined(P18F66J50) || defined(P18F65J50)
		//On the PIC18F87J50 Family of USB microcontrollers, the PLL will not power up and be enabled
		//by default, even if a PLL enabled oscillator configuration is selected (such as HS+PLL).
		//This allows the device to power up at a lower initial operating frequency, which can be
		//advantageous when powered from a source which is not gauranteed to be adequate for 48MHz
		//operation.  On these devices, user firmware needs to manually set the OSCTUNE<PLLEN> bit to
		//power up the PLL.
	    {
	        unsigned int pll_startup_counter = 600;
	        OSCTUNEbits.PLLEN = 1;  //Enable the PLL and wait 2+ms until the PLL locks before enabling USB module
	        while(pll_startup_counter--);
	    }
	    //Device switches over automatically to PLL output after PLL is locked and ready.
	    #endif


	//Interrupt-Initialisierungs-Kode
	


	//
	//Aufruf Komponenten-Makro: ret=USBSerial(0)::Initialise_Serial
	FCV_RET = FCD_USBSerial0_Initialise_Serial();


	//Entscheidung
	//Entscheidung: ret?
	if (FCV_RET)
	{
		//
		//Output: 1 -> C0
		trisc = trisc & 0xfe;
		if (1)
			portc = (portc & 0xfe) | 0x01;
		else
			portc = portc & 0xfe;


	} else {
		//
		//Schleife: While 1
		while (1)
		{
			//
			//Aufruf Komponenten-Makro: ret=USBSerial(0)::SendString("USB Test ... ")
			FCV_RET = FCD_USBSerial0_SendString("USB Test ... ",13);


			//
			//Output: 1 -> C0
			trisc = trisc & 0xfe;
			if (1)
				portc = (portc & 0xfe) | 0x01;
			else
				portc = portc & 0xfe;


			//
			//Warten: 500 ms
			delay_ms(255);
			delay_ms(245);


			//
			//Output: 0 -> C0
			trisc = trisc & 0xfe;
			if (0)
				portc = (portc & 0xfe) | 0x01;
			else
				portc = portc & 0xfe;


			//
			//Warten: 500 ms
			delay_ms(255);
			delay_ms(245);


		}


	}


	mainendloop: goto mainendloop;
}

void MX_INTERRUPT_MACRO(void)
{
		usb_handle_isr();

}



